;=======================================================================
;						  .
;=======================================================================
;			  :
;		 		- PIC16F84A-04I/P
;		   	- DS1307
;		 		- DS1621
;=======================================================================
;			  :
;		R (17)  - _1  .
;		R1 (18)  - _2  .
;		RA2 (l)   - SCL.
;		RA3 (2)   - SDA.
;		R4 (3)   - .
;		R0 - R3 -   .
;		R4 (10)  -   .
;		R5 (11)  -  .
;		R6 (12)  -     .
;		R7 (13)  -     .
;=======================================================================
			list      p=16F84A
			#include <p16F84A.inc>
			__CONFIG _CP_OFF&_WDT_ON&_PWRTE_ON&_XT_OSC
;=======================================================================
;							 .
;=======================================================================
w_temp		EQU		0x10	;    .
dig_L		equ		0x11	;   .
dig_H		equ		0x12	;   .
cnt1		EQU		0x13	;   .
cnt2		EQU		0x14	;   .
cnt3		EQU		0x15	;    .
cnt_dig		EQU		0x16	;   .
cnt_ON		EQU		0x17	;   .
cnt_Ind		EQU		0x18	;   .
cnt_ind		EQU		0x19	;   .
Digit		EQU		0x1A	;    .
digit_1		EQU		0x1B	;    .
digit_2		EQU		0x1C	;    .
digit_3		EQU		0x1D	;    .
digit_4		EQU		0x1E	;    .
;=======================================================================
;						   .
;=======================================================================
digbell_1	EQU		0x1F	;   .
digbell_2	EQU		0x20	;   .
digbell_3	EQU		0x21	;   .
digbell_4	EQU		0x22	;   .
cnt_bel		EQU		0x23	;    .
HourImpuls	EQU		0x24	;    .
cnt_Bell	EQU		0x25	;    .
Temp		EQU		0x26	;    .
M			EQU		0x27	;     .
cnt_Bipp	EQU		0x28	;    .
ADRES		EQU		0x29	;     .
;=======================================================================
;							 EEPROM.
;=======================================================================
temp_RD		EQU		0x30	;   .
temp_WR		EQU		0x31	;   .
cnt_ADR		EQU		0x32	;  .
cnt_DATA	EQU		0x33	;  .
EEAdr		EQU		0x09
EEData		EQU		0x08
EECon1		EQU		0x88
EECon2		EQU		0x89
IntCon		EQU		0x0B
Status		EQU		0x03
;=======================================================================
;							 .
;=======================================================================
digcel_1	EQU		0x34
digcel_2	EQU		0x35
digcel_3	EQU		0x36
digcel_4	EQU		0x37
cntCels		EQU		0x38	;   .
TempL		EQU		0x39
Count		EQU		0x3A
MinImpuls	EQU		0x3B	;    .
;=======================================================================
;								.
;=======================================================================
flag		EQU		0x3C	; .
key			EQU		0x3D	;   .
indic		EQU		0x3E	;  .
;-----------------------------------------------------------------------
;	flag, 0	=1	-	    .
;	flag, 1	=0	-	  .?
;			=1	-	  .?
;	flag, 2	=0	-	  .
;			=1	-	  .
;	flag, 3	=1	-	 .
;	flag, 4	=1	-	  .
;	flag, 5	=1	-	  .
;	flag, 6	=1	-	   .
;-----------------------------------------------------------------------
;	key, 0	=1	-	   .
;	key, 1  =1  -      1.
;	key, 2  =1  -      2.
;	key, 3  =1  -      3.
;	key, 4  =1  -      4.
;-----------------------------------------------------------------------
;	indic, 1	-	  .
;	indic, 2	-	  .
;	indic, 3	-	  .
;	indic, 4	-	   .
;=======================================================================
;	       I2C.
;=======================================================================
STATU		EQU		0x40	;  .
FLAG		EQU		0x41	;    .
I2CDEV		EQU		0x42	;  .
ERCODE		EQU		0x43	;   (   ).
ADDR		EQU		0x44	;  .
DATAI		EQU		0x45	;     .
DATAO		EQU		0x46	;     .
DATAI_1		EQU		0x47	;     .
DATAO_1		EQU		0x48	;     .
SLAVE		EQU		0x49	;   (YYYYxxxO).
TXBUF		EQU		0x4A	;  .
RXBUF		EQU		0x4B	;   .
COUNT		EQU		0x4C	;  .
;=======================================================================
;		  ()     I2C.
;=======================================================================
ERR1		EQU		0       ; -  (  ).
SDA			EQU		3       ; RA3, /  (SDA).
SCL			EQU		2       ; RA2,    (SCL).
DI			EQU		7       ;     I2C.
DO			EQU		6       ;    I2C.
;=======================================================================
	ORG		0x00
	goto	Start
;=======================================================================
;				     .
;=======================================================================
Convert
	addwf	PCL, f
;			 'EDCHGFAB'
	retlw	b'00011000'		; 0
	retlw	b'11011110'		; 1
	retlw	b'00110100'		; 2
	retlw	b'10010100'		; 3
	retlw	b'11010010'		; 4
	retlw	b'10010001'		; 5
	retlw	b'00010001'		; 6
	retlw	b'11011100'		; 7
	retlw	b'00010000'		; 8
	retlw	b'10010000'		; 9
	retlw	b'01010000'		; A
	retlw	b'00010011'		; B
	retlw	b'00111001'		; C -  "  ".
	retlw	b'11110000'		; D -  "  ".
	retlw	b'00110001'		; E
	retlw	b'11111111'		; F -  .
;=======================================================================
;							 .
;=======================================================================
Start
	clrf	PORTA			;    .
	clrf	PORTB
	clrf	indic
	clrf	cnt_Bipp
	clrf	key
	clrf	flag
	clrf	MinImpuls
	clrf	HourImpuls
	clrf	M
	clrf	cnt_ON
	clrf	Digit
	clrf	cnt3
;	clrf	digit_1
;	clrf	digit_2
;	movlw	5
;	movwf	digit_3
;	clrf	digit_4

;-----------------------------------------------------------------------
;								.
;-----------------------------------------------------------------------
	bsf		STATUS, RP0		; bank 1
	movlw	b'01110010'		;   PORTB, 
	movwf	OPTION_REG		;   TMR0, . . = 1:8
	movlw	03				; b'00000011'
	movwf	PORTA			; RA4 - RA2 , RA1 - RA0 .
	movlw	0				; b'00000000'
	movwf	PORTB			; RB7 - RB0 .
	bcf		STATUS, RP0		; bank 0
	movlw	0x3F			; b'00111111'
	movwf	TRISB			; RB7-RB6 = 0, RB5-RB0 = 1.
;-----------------------------------------------------------------------
	bsf		flag, 6			;     .
	call	READ_EPROM		;     EEPROM.
	movf	digbell_1, W
	movwf	w_temp			;   FF  EEPROM  
	incfsz	w_temp, f		;    .
	goto	Install
	clrf	digbell_1
	clrf	digbell_2
;	movlw	5
	clrf	digbell_3
	clrf	digbell_4
	goto	Install
;=======================================================================
;			     EEPROM.
;=======================================================================
READ_EPROM
	movlw	3				;    
	movwf	cnt_bel			; .
	movlw	5				;    .
	movwf	cnt_ADR			;    .
;=======================================================================
;					     EEPROM.
;=======================================================================
ADR_RD
	decfsz	cnt_ADR, f		;     =0,
	goto	load_DATA_RD
	return					;    .
load_DATA_RD
	movf	cnt_ADR, W
	movwf	cnt_DATA
	call	READ			;  .
	decfsz	cnt_DATA, f
	goto	$+3
	movwf	digbell_4		;     .
	goto	ADR_RD
	decfsz	cnt_DATA, f
	goto	$+3
	movwf	digbell_3		;     .
	goto	ADR_RD
	decfsz	cnt_DATA, f
	goto	$+3
	movwf	digbell_2		;     .
	goto	ADR_RD
	decf	cnt_DATA, f
	movwf	digbell_1		;     .
	goto	ADR_RD
;=======================================================================
;								 EEPROM.
;=======================================================================
READ
	bcf		EECon1, 2		;  , byt_2=0.
	movf	cnt_ADR, W
	movwf	EEAdr			;    .
	bsf		Status, RP0		;    1.
	bsf		EECon1, RD		;     EEPROM.
	bcf		Status, RP0		;    0.
	movf	EEData, W		;   EEData -> W.
	movwf	temp_RD			;   W -> temp_RD.
	return
;=======================================================================
;				     EEPROM.
;=======================================================================
WRITE_EPROM
	movlw	0
	movwf	IntCon		;  .
	movlw	5
	movwf	cnt_ADR		;     .
write
	call	ADR_WR		;    .
	movwf	temp_WR		;     .
;-----------------------------------------------------------------------
;								 EEPROM.
;-----------------------------------------------------------------------
WRITE
	movf	cnt_ADR, W
	movwf	EEAdr		;    .
	movf	temp_WR, W
	movwf	EEData		;  .
	bsf		Status, RP0
	bsf		EECon1, 2	;  
	movlw	055h
	movwf	EECon2
	movlw	0AAh
	movwf	EECon2
	bsf		EECon1, WR	;   .
wr1
	btfss	EECon1, 4	;   .
	goto	wr1
	bcf		EECon1, 4	;   " ".
	bcf		Status, RP0
	goto	write		;      .
;-----------------------------------------------------------------------
;	call	READ		;  .
;-----------------------------------------------------------------------
;Verify
;	movf	temp_WR, W	;  .
;	movwf	Temp
;	movf	temp_RD, W	;  .
;	subwf	Temp, f		;  .
;	btfsc	STATUS, Z	;   =0,  .
;	goto	write		;      .
;	goto	WRITE		;  =0 ,   ,  .
;=======================================================================
;					     EEPROM.
;=======================================================================
ADR_WR
	decfsz	cnt_ADR, f
	goto	load_DATA_WR
	return				;   =0,   .
load_DATA_WR
	movf	cnt_ADR, W
	movwf	cnt_DATA
	decfsz	cnt_DATA, f
	goto	$+3
	movf	digbell_4, W
	return
	decfsz	cnt_DATA, f
	goto	$+3
	movf	digbell_3, W
	return
	decfsz	cnt_DATA, f
	goto	$+3
	movf	digbell_2, W
	return
	decf	cnt_DATA, f
	movf	digbell_1, W
	return
;=======================================================================
;					  ( DS1621 ).
;=======================================================================
Install
	movlw	0x9E			;   SLAVE  .
	movwf	SLAVE
	movlw	0xAC			;    .
	movwf	ADDR
	movlw	0x0B			;  : POL-high, ISHOT-yes.
	movwf	DATAO
	call	WRBYTE			;   .
	nop						;  .
	movlw	0x9E			;   .
	movwf	SLAVE
	movlw	0xEE			;    .
	movwf	ADDR
	call	WRCOM			;    .
	nop						;  .
;=======================================================================
;						  ( DS1307 ).
;=======================================================================
	movlw	0xD0			;   .
	movwf	SLAVE			;   .
	movlw	0x00			;    .
	movwf	ADDR
	call	RDBYTE			;   ?
	btfsc	DATAI, 7		;    , 
	goto	$+4				; , 
	call	clock			;   .
	call	Count_Imp_1		;   .
	goto	Main			;   ,
							;  -  .
;-----------------------------------------------------------------------
;								.
;-----------------------------------------------------------------------
	movlw	0xD0			;     .
	movwf	SLAVE
	clrw
	movwf	ADDR			;   .
	movwf	DATAO			;   .
	call	WRBYTE			;  .
	nop
	movlw	0xD0			;     .
	movwf	SLAVE
	movlw	0x01			;   .
	movwf	ADDR
	movlw	0x00			;   .
	movwf	DATAO
	call	WRBYTE
	nop
	movlw	0xD0			;     .
	movwf	SLAVE
	movlw	0x02			;   .
	movwf	ADDR
	movlw	0x00			;   .
	movwf	DATAO
	call	WRBYTE
	nop
	movlw	0xD0			;     .
	movwf	SLAVE
	movlw	0x07			;   .
	movwf	ADDR			;    24 ,
	movlw	0x91			;   1   Tout.
	movwf	DATAO
	call	WRBYTE
	nop
	goto	Main
;=======================================================================
;	      .
;=======================================================================
Count_Imp_1
;Count_Imp
	btfsc	digit_1, 1	;      2.
	goto	cnt_imp_2	; 
	btfsc	digit_1, 0	;      1.
	goto	cnt_imp_1	; 
	movf	digit_2, W
	movwf	M
	return
cnt_imp_1
	movf	digit_2, W
	movwf	M
	movlw	2
	subwf	M, f		;    .
	movf	M, W
	btfsc	STATUS, C	;   <0,   goto.
	goto	cnt_imp_1.1
	movf	digit_2, W
	movwf	M
	movlw	0x0A
	addwf	M, f		;    .
	return
cnt_imp_1.1
	movf	M, W
	btfss	STATUS, Z
	return
	movlw	0x0C
	movwf	M
	return
cnt_imp_2
	movf	digit_2, W
	movwf	M
	movlw	8
	addwf	M, f		;    .
	return
;=======================================================================
;                         .
;=======================================================================
clock
	movlw	0xD0
	movwf	SLAVE
	movlw	0x01
	movwf	ADDR
	call	RDBYTEN			;   : 01, 02H.
	movf	DATAI, W
	andlw	0x0F
	movwf	digit_4
	swapf	DATAI, F
	movf	DATAI, W
	andlw	0x07
	movwf	digit_3
	movf	DATAI_1, W
	andlw	0x0F
	movwf	digit_2
	swapf	DATAI_1, F
	movf	DATAI_1, W
	andlw	0x03
	movwf	digit_1
	return
;=======================================================================
;				     DS1621.
;=======================================================================
Celsio
	movlw	0x9E		;   .
	movwf	SLAVE
	movlw	0xAA		;  .
	movwf	ADDR
	call	RDBYTEN		; MSB-LSB
;-----------------------------------------------------------------------
	bcf		DATAI, 7
	call	ConvBinDec
;-----------------------------------------------------------------------
	movlw	0x9E		;   .
	movwf	SLAVE
	movlw	0xEE		;     .
	movwf	ADDR
	call	WRCOM
	return
;=======================================================================
;		        
;				 TEMP    .
;=======================================================================
ConvBinDec
	clrf	dig_H		;   .
	movf	DATAI, W	;     W.
	movwf	dig_L		;   dig_L.
	swapf	dig_L, W	;      ,
	addwf	dig_L, W	;      .
	andlw	0x0F
	skpndc			;      DC .
	addlw	0x16
	skpndc			;      DC .
	addlw	0x06
	addlw	0x06
	skpdc				;     DC e.
	addlw	-0x06
	btfsc	dig_L, 4
	addlw	0x16 - 1 + 0x06
	skpdc				;     DC e.
	addlw	-0x06
	btfsc	dig_L, 5
	addlw	0x30
	btfsc	dig_L, 6
	addlw	0x60
	btfsc	dig_L, 7
	addlw	0x20
	addlw	0x60
	rlf		dig_H, f
	btfss	dig_H, 0
	addlw	-0x60
	movwf	TempL
;-----------------------------------------------------------------------
;	  BIN>DEC,      .
;-----------------------------------------------------------------------
	movlw	0x0F		;  2-.
	andwf	TempL, W	; select 1dec. low razr.
	movwf	digcel_2	; 2 -  .
	movlw	0xF0		;  1-.
	andwf	TempL, f	;
	swapf	TempL, W	;
	movwf	digcel_1	; 1 -  .
	movlw	0x0C		;  ""  4- .
	movwf	digcel_4
	movlw	0x0D		;  ""  3- .
	movwf	digcel_3
	return
;=======================================================================
;						  .
;=======================================================================
Main
	btfss	flag, 3		;     ,
	call	Temperatur	; =0   .
	call	LED			;   .
	call	clock		;   .
	movf	cnt_ON, W	;   .
	btfss	STATUS, Z	; =0      .
	call	Bipper		;    .
	call	Bell		;  .
	call	Ind_LED		;    .
	goto	Main
;=======================================================================
;			  -   .
;=======================================================================
LED
	decfsz	w_temp, f
	goto	$+2
	bcf		indic, 2
	btfss	indic, 3	;   .
	goto	led
	decfsz	cntCels, f	;   .
	goto	led
	bcf		indic, 3
led
	movf	cnt_ON, W	; cnt_ON -> W.
	btfss	STATUS, Z	;  .
	goto	clr_ON		; =1   .
	bsf		cnt_ON, 0	; =0  .
	return
clr_ON
	bcf		cnt_ON, 0	;  .
	return
;=======================================================================
;					    
;							  .
;=======================================================================
Temperatur
	movf	digit_4, W		;    .
	subwf	MinImpuls, f	;     MinImpuls.
	movf	MinImpuls, f	;  >0   .
	btfss	STATUS, Z		;  =0  goto.
	goto	TempInd			;  >0   .
	movwf	MinImpuls		;   MinImpuls.
	return
;-----------------------------------------------------------------------
TempInd
	movwf	MinImpuls	;   MinImpuls.
	bsf		indic, 3	;    .
	movlw	5
	movwf	cntCels		;    .
	call	Celsio		;    .
	return
;=======================================================================
;					    .
;=======================================================================
Bipper
	movf	digit_2, W		;    .
	subwf	HourImpuls, f	;     HourImpuls.
	movf	HourImpuls, f	;  >0   .
	btfss	STATUS, Z		;  =0  goto.
	goto	Bipp			;  >0  .
;-----------------------------------------------------------------------
;						  .
;-----------------------------------------------------------------------
	movf	cnt_Bipp, f	; cnt_Bipp -> f.
	btfsc	STATUS, Z	;   .
	goto	$+3			;  =0   .
	decf	cnt_Bipp, f	; >0      
	goto	$+2			;    .
;-----------------------------------------------------------------------
	bcf		indic, 4	;   .
	movwf	HourImpuls	;   HourImpuls.
	return
;-----------------------------------------------------------------------
;							 .
;-----------------------------------------------------------------------
Bipp
	movf	digit_2, W	;      .
	movwf	HourImpuls	;  .   .
	bsf		indic, 4	;   .
	call	Count_Imp_1	;     .
	movf	M, W		;      .
	movwf	cnt_Bipp	;    .
	return
;=======================================================================
;						  .
;=======================================================================
Bell
	btfss	flag, 5		;    .
	goto	set_bell
	movf	cnt_Bell, W
	btfss	STATUS, Z
	decfsz	cnt_Bell, f	;     .
	return
	bcf		flag, 5
	return				;   .
set_bell
	movf	digit_1, W	;     
	movwf	dig_H		;  .
	movf	digbell_1, W ;     
	subwf	dig_H, f	;  .
	btfss	STATUS, Z	; =0   .
	return				;  =0   .
	movf	digit_2, W	;     
	movwf	dig_H		;  .
	movf	digbell_2, W ;     
	subwf	dig_H, f	;  .
	btfss	STATUS, Z	; =0   .
	return				;  =0   .
	movf	digit_3, W	;     
	movwf	dig_H		;  .
	movf	digbell_3, W ;     
	subwf	dig_H, f	;  .
	btfss	STATUS, Z	; =0   .
	return				;  =0   .
	movf	digit_4, W	;     
	movwf	dig_H		;  .
	movf	digbell_4, W ;     
	subwf	dig_H, f	;  .
	btfss	STATUS, Z	; =0   .
	return				;  =0   .
	bsf		flag, 5		;    .
	movlw	0x78		;    
	movwf	cnt_Bell	;   (120).
	incf	digbell_3, f
	movf	digbell_3, W
	movwf	dig_L
	movlw	6
	subwf	dig_L, f
	movf	dig_L, W
	btfss	STATUS, Z
	goto	inc
	clrf	digbell_3
	incf	digbell_2, f
inc
	decfsz	cnt_bel, f
	return
	call	READ_EPROM
	return
;=======================================================================
;          4-   LED-.
;=======================================================================
Ind_LED
	movlw  	0x28
	movwf   cnt_Ind		;    .
loop_Ind
	movf	cnt3, W		;    .
	btfsc	STATUS, Z
	goto	loop_I
	decf	cnt3, f
loop_I
	call    Skaner		;   .
	decfsz  cnt_Ind, f	; cnt_ind=cnt_ind-1
	goto    loop_Ind
	return
;=======================================================================
;					  .
;=======================================================================
Skaner
	movf	digcel_1, W	;   .
	btfss	indic, 3	;  =1   .
	movf	digit_1, W	;   .
	btfsc	indic, 2	;  =1   .
	movf	digbell_1, W;   .
	call	Convert		;    .
	movwf	Digit		;      .
	call	Indicator	;   .
	call	Led_ON		;   .
	bsf		key, 1		;    1.
	call	Activ_1		;   .
	call	Delay		;    .
	bsf		PORTB, 0	;   .
	bcf		key, 1		;    1.
;-----------------------------------------------------------------------
	movf	digcel_2, W	;   .
	btfss	indic, 3	;  =1   .
	movf    digit_2, W	;   .
	btfsc	indic, 2	;  =1   .
	movf	digbell_2, W;   .
	call	Convert		;    .
	movwf	Digit		;      .
	call	Indicator	;   .
	call	Led_ON		;   .
	bsf		key, 2		;    2.
	call	Activ_2		;   .
	call    Delay		;    .
	bsf		PORTB, 1	;   .
	bcf		key, 2		;    2.
;-----------------------------------------------------------------------
	movf	digcel_3, W	;   .
	btfss	indic, 3	;  =1   .
	movf    digit_3, W	;   .
	btfsc	indic, 2	;  =1   .
	movf	digbell_3, W;   .
	call	Convert		;    .
	movwf	Digit		;      .
	call	Indicator	;   .
	call	Led_ON		;   .
	bsf		key, 3		;    3.
	call	Activ_3		;   .
	call    Delay		;    .
	bsf		PORTB, 2	;   .
	bcf		key, 3		;    3.
;-----------------------------------------------------------------------
	movf	digcel_4, W	;   .
	btfss	indic, 3	;  =1   .
	movf    digit_4, W	;   .
	btfsc	indic, 2	;  =1   .
	movf	digbell_4, W;   .
	call	Convert		;    .
	movwf	Digit		;      .
	btfsc	flag, 0		;      .
	bcf		Digit, 4	; =1    4.
	call	Indicator	;   .
	call	Led_ON		;   .
	bsf		key, 4		;    4.
	call	Activ_4		;   .
	call    Delay		;    .
	bsf		PORTB, 3	;   .
	bcf		key, 4		;    4.
	return
;=======================================================================
;				     .
;=======================================================================
Indicator
	movlw	8
	movwf	cnt_dig		;      .
Count_dig
	bcf		PORTB, 6	;  RB6.
	btfsc	Digit, 0	;    .
	bsf		PORTB, 6	; =1    RB6.
	nop					; .
	bsf		PORTB, 7	;    RB7,    .
	nop					; .
	bcf		PORTB, 7	;  RB7. ( _||_ ).
	rrf		Digit, f	;      .
	decfsz	cnt_dig, f
	goto	Count_dig
	bcf		PORTB, 6	;  RB6.
	return
;=======================================================================
;					    .
;=======================================================================
Led_ON
	bsf		PORTB, 4	;    .
	bsf		PORTB, 5	;   .
	btfsc	cnt_ON, 0	;    .
	goto	sign_ON		; =1    .
	bcf		PORTA, 4	; =0  ,
	return				;    .
sign_ON
	bcf		PORTB, 5	;   .
	btfsc	flag, 6		;     .
	bcf		PORTB, 4	; =1    
	btfsc	flag, 5		;    .
	goto	sign_bell	; =1  .
	btfss	flag, 0		;     .
	return				; =0 .
	movf	cnt_Bipp, f
	btfss	STATUS, Z	;     .
	goto	set_signal	; >0    .
	return				; =0 .
sign_bell
	btfsc	flag, 6		;       .
	btfss	flag, 5		;    .
	return				; =0   .
	movf	cnt_Bell, W
	btfss	STATUS, Z
	goto	set_signal	; >0     .
	bcf		flag, 5		;    .
	return
set_signal
	btfss	cnt_ON, 0	;    .
	goto	clr_signal	; =0  .
	bsf		PORTA, 4	; =1  .
	return
clr_signal
	bcf		PORTA, 4	; =0  .
	return
;=======================================================================
;						  .
;=======================================================================
Activ_1
	btfss	flag, 3		;   .
	goto	loop_OF_1
	btfss	flag, 2		;      
	goto	loop_OF_1
	goto	loop_OFF_1	; =1     .
loop_OF_1
	bcf		PORTB, 0	; B  .
	return
loop_OFF_1
	btfsc	cnt_ON, 0	;   .
	bcf		PORTB, 0	; =1   .
	return				; =0    .
;-----------------------------------------------------------------------
Activ_2
	btfss	flag, 3
	goto	loop_OF_2
	btfss	flag, 2		;      
	goto	loop_OF_2
	goto	loop_OFF_2
loop_OF_2
	bcf		PORTB, 1	;   .
	return
loop_OFF_2
	btfsc	cnt_ON, 0
	bcf		PORTB, 1	;   .
	return
;-----------------------------------------------------------------------
Activ_3
	btfss	flag, 3
	goto	loop_OF_3
	btfsc	flag, 2		;      
	goto	loop_OF_3
	goto	loop_OFF_3
loop_OF_3
	bcf		PORTB, 2	;   .
	return
loop_OFF_3
	btfsc	cnt_ON, 0
	bcf		PORTB, 2	;   .
	return
;-----------------------------------------------------------------------
Activ_4
	btfss	flag, 3
	goto	loop_OF_4
	btfsc	flag, 2		;      
	goto	loop_OF_4
	goto	loop_OFF_4
loop_OF_4
	bcf		PORTB, 3	;   .
	return
loop_OFF_4
	btfsc	cnt_ON, 0
	bcf		PORTB, 3	;   .
	return
;=======================================================================
;			     
;							  .
;=======================================================================
Delay
	movf	cnt3, W		;     .
	btfsc	STATUS, Z	; =0    .
	call	Key			;  .
;-----------------------------------------------------------------------
	movlw   .10
	movwf   cnt1		; .10 -> cnt1
loop1 
	movlw   .100
	movwf   cnt2		; .100 -> cnt2
	clrwdt				;   .
loop2
	decfsz  cnt2, f		; cnt2=cnt2-1
	goto	loop2
	decfsz  cnt1, f
	goto	loop1
	return
;=======================================================================
;					   .
;=======================================================================
Key
	btfss	PORTA, 0	;   RA0 = 0
	goto	Key_1		;   .
	btfss	PORTA, 1	;   RA1 = 0
	goto	Key_2		;   .
	return				;  .
;-----------------------------------------------------------------------
Key_1
	movlw	0x20		;   
	movwf	cnt3		;  .
;	btfsc	key, 1		;   Sb1?
;	goto	Sb_1		; ?     .
;	btfsc	key, 2		;   Sb2?
;	goto	Sb_2		; ?     .
	btfsc	key, 3		;   Sb3? , .
	goto	Sb_3		; ?     .
	btfsc	key, 4		;   Sb4? , .
	goto	Sb_4		; ?     .
	return
Key_2
	movlw	0x20		;   
	movwf	cnt3		;  .
	btfsc	key, 1		;   Sb5?
	goto	Sb_5		; ?     .
	btfsc	key, 2		;   Sb6?
	goto	Sb_6		; ?     .
	btfsc	key, 3		;   Sb7? , .
	goto	Sb_7		; ?     .
	btfsc	key, 4		;   Sb8? , .
	goto	Sb_8		; ?     .
	return
;-----------------------------------------------------------------------
;Sb_1					; .
;	return
;-----------------------------------------------------------------------
;Sb_2					; .
;	return
;-----------------------------------------------------------------------
Sb_3					;    .
	btfsc	flag, 0		;    .
	goto	bipp_OFF
	bsf		flag, 0		; =0  .
	return
bipp_OFF
	bcf		flag, 0		;  .
	return
;-----------------------------------------------------------------------
Sb_4					;  .
	btfsc	indic, 1	;   .
	goto	loop_time_1
	bsf		indic, 1	; =0   .
	bsf		flag, 3		;   .
	return
loop_time_1
	btfsc	flag, 2		;      .
	goto	loop_time_2
	bsf		flag, 2		; =0    .
	return
loop_time_2
	bcf		indic, 1
	bcf		flag, 3
	bcf		flag, 2
	return
;-----------------------------------------------------------------------
Sb_5					;   .
	btfsc	flag, 6
	goto	OFF_bell
	bsf		indic, 2	;    
	movlw	5			;   
	movwf	w_temp		;  .
	bsf		flag, 6		;    .
	return
OFF_bell
	bcf		flag, 6		;    .
	return
;-----------------------------------------------------------------------
Sb_6					;  [ + ].
	btfsc	flag, 3		;   .
	goto	Setup		; =1   .
	return
;-----------------------------------------------------------------------
Sb_7					;  .
	btfsc	indic, 2	;  indic, 2 =0,   .
	goto	loop_bell_1
	bsf		indic, 2
	return
loop_bell_1
	btfsc	flag, 3		;    .
	goto	loop_bell_2
	bsf		flag, 3		;   .
	return
loop_bell_2
	btfsc	flag, 2		;     .
	goto	loop_bell_3
	bsf		flag, 2		;    .
	return
loop_bell_3
	bcf		flag, 2		;      .
	bcf		flag, 3		;   .
	call	Ind_LED
	bcf		indic, 2
	call	WRITE_EPROM	;     EEPROM.
	return
;-----------------------------------------------------------------------
Sb_8					;  [ - ].
	btfsc	flag, 3		;   .
	goto	Setup		; =1   .
	return
;=======================================================================
;					   .
;=======================================================================
Setup
	bsf		cnt_ON, 0	;     .
	btfsc	indic, 2	;   .
	goto	Set_Bell	; =1    .
	btfsc	indic, 1	;   .
	goto	Set_Clock	; =1    .
;-----------------------------------------------------------------------
Set_Bell
	btfss	flag, 2		;      .
	goto	set_minute	; =0    .
	movf	digbell_1, W;      
	movwf	dig_H		;  . 
	movf	digbell_2, W
	movwf	dig_L
;-----------------------------------------------------------------------
	btfsc	key, 2		;   .
	goto	Hourplus
	btfsc	key, 4
	goto	Hourminus
;-----------------------------------------------------------------------
set_minute
	movf	digbell_3, W;      
	movwf	dig_H		;  .
	movf	digbell_4, W
	movwf	dig_L
;-----------------------------------------------------------------------
	btfsc	key, 2		;   .
	goto	Minuteplus
	btfsc	key, 4
	goto	Minuteminus
	return
;-----------------------------------------------------------------------
Set_Clock
	btfss	flag, 2		;      .
	goto	set_minute_1
	movlw	0xD0		;   .
	movwf	SLAVE
	movlw	0x02		;     .
	movwf	ADDR
	movwf	ADRES		;   .
	call	RDBYTE		;   .
	call	Set_temp	;     .
;-----------------------------------------------------------------------
	btfsc	key, 2		;   .
	goto	Hourplus
	btfsc	key, 4
	goto	Hourminus
;-----------------------------------------------------------------------
set_minute_1
	movlw	0xD0		;   .
	movwf	SLAVE
	movlw	0x01		;     .
	movwf	ADDR
	movwf	ADRES		;   .
	call	RDBYTE		;   .
	call	Set_temp	;     .
;-----------------------------------------------------------------------
	btfsc	key, 2		;   .
	goto	Minuteplus
	btfsc	key, 4
	goto	Minuteminus
	return
;-----------------------------------------------------------------------
;						  [+ ].
;-----------------------------------------------------------------------
Hourplus
	btfss	dig_H, 1	;      2
	goto	hihgp1		;    .
	movf	dig_L, W
	sublw	0x03
	btfss	STATUS, Z	;       3
	goto	hihgp2		;    .
	clrf	dig_L		;   3   
	clrf	dig_H		;  .  = 00.
	goto	Set_Work_H
hihgp1
	movf	dig_L, W
	addlw	0x01
	movwf	dig_L		;     +1.
	sublw	0x0A
	btfsc	STATUS, Z	;      9,
	goto	hihgp3		;    .
	goto	Set_Work_H
hihgp2
	movf	dig_L, W
	addlw	0x01
	movwf	dig_L		;     +1.
	goto	Set_Work_H
hihgp3
	clrf	dig_L		;   .
	incf	dig_H, f	;  +1   .
	goto	Set_Work_H
;-----------------------------------------------------------------------
;						  [- ].
;-----------------------------------------------------------------------
Hourminus
	movf	dig_H, W
	btfss	STATUS, Z	;    = 0 .
	goto	hihgm1		;  > 0   hihgm1.
	movf	dig_L, W
	btfss	STATUS, Z	;    = 0 .
	goto	hihgm3		;  > 0   hihgm3.
	movlw	0x02
	movwf	dig_H		;       
	movlw	0x03		; 00,      23
	movwf	dig_L
	goto	Set_Work_H
hihgm1
	movf	dig_L, W
	btfsc	STATUS, Z	;    > 0 .
	goto	hihgm2
	decf	dig_L, f	;     1.
	goto	Set_Work_H
hihgm2
	movlw	0x09
	movwf	dig_L		;    9.
	decf	dig_H, f	;     1.
	goto	Set_Work_H
hihgm3
	decf	dig_L, f	;     1.
	goto	Set_Work_H
;-----------------------------------------------------------------------
;						  [+ ].
;-----------------------------------------------------------------------
Minuteplus
	movf	dig_H, W
	sublw	0x05
	btfss	STATUS, Z	;      5
	goto	hihmp1		;    .
	movf	dig_L, W
	sublw	0x09
	btfss	STATUS, Z	;       9
	goto	hihmp2		;    ,
	clrf	dig_L		;   9   
	clrf	dig_H		;  .  = 00.
	goto	Set_Work_M
hihmp1
	movf	dig_L, W
	addlw	0x01
	movwf	dig_L		;     +1.
	sublw	0x0A
	btfsc	STATUS, Z	;      9,
	goto	hihmp3		;    .
	goto	Set_Work_M
hihmp2
	movf	dig_L, W
	addlw	0x01
	movwf	dig_L		;     +1.
	goto	Set_Work_M
hihmp3
	clrf	dig_L		;   .
	incf	dig_H, f	;  1   .
	goto	Set_Work_M
;-----------------------------------------------------------------------
;						  [- ].
;-----------------------------------------------------------------------
Minuteminus
	movf	dig_H, W
	btfss	STATUS, Z	;    > 0 .
	goto	hihgmm1		;  > 0   hihgm1.
	movf	dig_L, W
	btfss	STATUS, Z	;    > 0 .
	goto	hihgmm3		;   0   hihgm3.
	movlw	0x05
	movwf	dig_H		;       
	movlw	0x09		; 00,      59
	movwf	dig_L
	goto	Set_Work_M
hihgmm1
	movf	dig_L, W
	btfsc	STATUS, Z	;    > 0 .
	goto	hihgmm2
	decf	dig_L, f	;     1.
	goto	Set_Work_M
hihgmm2
	movlw	0x09
	movwf	dig_L		;    9.
	decf	dig_H, f	;     1.
	goto	Set_Work_M
hihgmm3
	decf	dig_L, f	;     1.
	goto	Set_Work_M
;-----------------------------------------------------------------------
;			     .
;-----------------------------------------------------------------------
Set_temp
	movwf	w_temp		;    .
	andlw	0x0F		;   
	movwf	dig_L		;  .
	swapf	w_temp, f	;      .
	movf	w_temp, W	;    .
	andlw	0x0F		;   
	movwf	dig_H		;  .
	return
;-----------------------------------------------------------------------
;			      
;							 .
;-----------------------------------------------------------------------
Set_Work
	swapf	dig_H, f	;      .
	movf	dig_H, W	;    ( W ).
	movwf	w_temp		;    .
	movf	dig_L, W	;   .  .
	iorwf	w_temp, f	;     .
	return
;-----------------------------------------------------------------------
Set_WrByte
	movlw	0xD0
	movwf	SLAVE
	movf	ADRES, W	;     
	movwf	ADDR		;   .
	movf	w_temp, W
	movwf	DATAO
	call	WRBYTE		;     .
	call	clock		;    .
Set_Wright
	call	Count_Imp_1	;   .
	return
;-----------------------------------------------------------------------
;			      
;					     .
;-----------------------------------------------------------------------
Set_Work_H
	call	Set_Work
;-----------------------------------------------------------------------
	btfss	indic, 2	;   .
	goto	Set_WrByte
	swapf	dig_H, f
	movf	dig_H, W	;     
	movwf	digbell_1	;      .
	movf	dig_L, W
	movwf	digbell_2
	goto	Set_Wright
;-----------------------------------------------------------------------
;			      
;					     .
;-----------------------------------------------------------------------
Set_Work_M
	call	Set_Work
;-----------------------------------------------------------------------
	btfss	indic, 2		;   .
	goto	Set_WrByte		;  =1     .
	swapf	dig_H, f
	movf	dig_H, W		;     
	movwf	digbell_3		;      .
	movf	dig_L, W
	movwf	digbell_4
	goto	Set_Wright
;=======================================================================



;=======================================================================
;					    I2C.
;=======================================================================
WRBYTE
	MOVF	SLAVE, W		;   
	MOVWF	TXBUF			;   
	CALL	BSTART			;   START
	CALL	TX				;   
	MOVF	ADDR, W			;   
	MOVWF	TXBUF			;   
	CALL	TX				;   
	MOVF	DATAO, W		;  
	MOVWF	TXBUF			;   
	CALL	TX				;    
							; 
	CALL	BSTOP			;   STOP
	RETURN
;=======================================================================
;					    I2C.
;=======================================================================
WRCOM
	MOVF	SLAVE, W		;   
	MOVWF	TXBUF			;   
	CALL	BSTART			;   START
	CALL	TX				;   
	MOVF	ADDR, W			;   
	MOVWF	TXBUF			;  
	CALL	TX				;  
	CALL	BSTOP           ;   STOP
	RETURN
;=======================================================================
;				      I2C.
;=======================================================================
WRBYTEN
	MOVF	SLAVE, W		;   
	MOVWF	TXBUF			;   
	CALL	BSTART			;   START
	CALL	TX				;   
	MOVF	ADDR, W			;   
	MOVWF	TXBUF			;   
	CALL	TX				;   
	MOVF	DATAO, W		;    
	MOVWF	TXBUF			;   
	CALL	TX				;    
							; 
	MOVF	DATAO_1, W		;    
	MOVWF	TXBUF			;   
	CALL	TX				;    
							; 
	CALL	BSTOP			;   STOP
	RETURN
;=======================================================================
;					     I2C.
;=======================================================================
RDBYTE
	MOVF	SLAVE, W		;   
	MOVWF	TXBUF			;    (R/W = 0)
	CALL	BSTART			;   START
	CALL	TX				;   
	MOVF	ADDR, W			;   
	MOVWF	TXBUF			;   
	CALL	TX				;   
	CALL	BSTART			;   START
	MOVF	SLAVE, W		;   
	MOVWF	TXBUF			;   
	BSF		TXBUF, 0		;   READ (R/W = 1)
	CALL	TX				;   
	CALL	RX				;    
	CALL	BSTOP			;   STOP
	MOVF	RXBUF, W		;  
	MOVWF	DATAI			;    DATAI
	RETURN
;=======================================================================
;				      I2C.
;=======================================================================
RDBYTEN
	MOVF	SLAVE, W		;   
	MOVWF	TXBUF			;    (R/W = 0)
	CALL	BSTART			;   START
	CALL	TX				;   
	MOVF	ADDR, W			;   
	MOVWF	TXBUF			;   
	CALL	TX				;   
	CALL	BSTART			;   START
	MOVF	SLAVE, W		;   
	MOVWF	TXBUF			;   
	BSF		TXBUF, 0		;   READ (R/W = 1)
	CALL	TX				;   
	CALL	RX0				;     
	MOVF	RXBUF, W		;  
	MOVWF	DATAI			;    DATAI
	CALL	RX				;     
	MOVF	RXBUF, W		;  
	MOVWF	DATAI_1			;    DATAI_1
	CALL	BSTOP			;   STOP
	RETURN
;=======================================================================
;					   START.
;=======================================================================
BSTART
	bcf		PORTA, 2		;  SDA, SCL  
	bcf		PORTA, 3		;    
	BSF		PORTA, SDA		;   ,  SDA=1
	BSF		PORTA, SCL		;  SCL=1
	MOVLW	1				;    1
	BTFSS	PORTA, SCL		;  ?
	CALL	ERR				;  ,   
	BCF		PORTA, SDA		;  SDA  0,  SCL=1
	NOP						;   
	NOP
	NOP
	BCF		PORTA, SCL		;  SCL, START 
	RETLW	0
;=======================================================================
;						  STOP.
;=======================================================================
BSTOP
	bcf		PORTA, 2		;  SDA, SCL  
	bcf		PORTA, 3		;    
	BCF		PORTA, SDA		;  SDA=0
	BSF		PORTA, SCL		;  SCL=1
	NOP						;   
	NOP
	NOP
	MOVLW	1				;    1
	BTFSS	PORTA, SCL		; SCL=1?
	CALL	ERR				; , SCL    
	BSF		PORTA, SDA		;  SDA  0  1,  SCL=O
	MOVLW	4				;    4
	BTFSS	PORTA, SDA		; SD=1?
	CALL	ERR				; , SDA    STOP
	RETLW	0
;=======================================================================
;				     I2C  PIC.
;=======================================================================
BITIN
	bcf		PORTA, 2		;  SDA - , SCL - 
	bsf		PORTA, 3		;    
	BSF		PORTA, SDA
	BCF		I2CDEV, DI		; DI=0
	BSF		PORTA, SCL		; SCL=1
	MOVLW	1				;   
	BTFSC	PORTA, SCL		; ,  SCL=0
	GOTO	BIT1
	BTFSS	FLAG, ERR1		;    ?
	MOVWF	ERCODE			;   
	BSF		FLAG, ERR1		;   
BIT1
	BTFSC	PORTA, SDA		;    SDA
	BSF		I2CDEV, DI		; DI=1 (  1)
	NOP						;  
	NOP
	BCF		PORTA, SCL		; SCL=0
	RETLW	0
;=======================================================================
;				    PIC   I2C
;=======================================================================
BITOUT
	bcf		PORTA, 2		;  SDA, SCL  
	bcf		PORTA, 3		;    
	BTFSS	I2CDEV, DO		; DO=0?
	GOTO	BIT0			;  ,   BIT0
	BSF		PORTA, SDA		; SDA=1
	MOVLW	2				;    2
	BTFSC	PORTA, SDA		;     2
	GOTO	CLK1			;   ,   CLK1
	BTFSS	FLAG, ERR1		;    ?
	MOVWF	ERCODE			;   
	BSF		FLAG, ERR1		;    
	GOTO	CLK1
BIT0
	BCF		PORTA, SDA		; SDA=0
	NOP						;  
	NOP
	NOP
	NOP
	NOP
CLK1
	BSF		PORTA, SCL		; SCL=1
	MOVLW	1				;    1
	BTFSC	PORTA, SCL		; SCL   ?
	GOTO	BIT2			;  ,   BIT2
	BTFSS	FLAG, ERR1		;  ,
	MOVWF	ERCODE			;   
	BSF		FLAG, ERR1		;    
BIT2
	NOP						;  
	NOP
	NOP
	BCF		PORTA, SCL		;  SCL  0
	RETLW	0
;=======================================================================
;			 8-    I2C  PIC.
;=======================================================================
RX
	MOVLW	.8				;   
	MOVWF	COUNT
	CLRF	RXBUF			;   
RXLP
	RLF		RXBUF, F		;       
	SKPC					; ,  CARRY=1
	BCF		RXBUF, 0		;    RXBUF
	SKPNC					; ,  CARRY=0
	BSF		RXBUF, 0		;   1   RXBUF
	CALL	BITIN			;    
	BTFSC	I2CDEV, DI		;    =1, 
	BSF		RXBUF, 0		;  1   RXBUF
	DECFSZ	COUNT, F		;   ?
	GOTO	RXLP			; , 
	BSF		I2CDEV, DO		;    ASK=1
	CALL	BITOUT			;    
							; 
	RETLW   0
;=======================================================================
;			 8- ,  ,  ASK=0.
;			      RXBUF.
;=======================================================================
RX0
	MOVLW	.8				;   
	MOVWF	COUNT
	CLRF	RXBUF			;   
RXLP0
	RLF		RXBUF, F
	SKPC
	BCF		RXBUF, 0
	SKPNC
	BSF		RXBUF, 0
	CALL	BITIN
	BTFSC	I2CDEV, DI
	BSF		RXBUF, 0
	DECFSZ	COUNT, F
	GOTO	RXLP0
	BCF		I2CDEV, DO		;    ASK=0(!!!)
	CALL	BITOUT			;    
							; 
	RETLW	0
;=======================================================================
; 			    PIC   I2C.
;=======================================================================
TX
	MOVLW	.8				;   
	MOVWF	COUNT
TXLP
	BCF		I2CDEV, DO		;    DO=0
	BTFSC	TXBUF, 7		;    = 0, DO=0
	BSF		I2CDEV, DO		;  DO=1
	CALL	BITOUT			;   
	RLF		TXBUF, F		;  TXBUF 
	SKPC					; f(6) ---> f(7)
	BCF		TXBUF, 0		; f(7)  > carry
	SKPNC					; carry > f(0)
	BSF		TXBUF, 0
	DECFSZ	COUNT, F		;   ?
	GOTO	TXLP			; , 
	CALL	BITIN			;    ASK
	MOVLW	3				;   
	BTFSC	I2CDEV, DI		;   ASK
	CALL	ERR				;    
	RETLW	0
;=======================================================================
;			     I2C
;		 :  W -  
;		 :  ERCODE -  
;						 FLAG(ERR1)=1

;				      

;	1   :		SCL   0 (  )
;	2   :		SDA   0 (  )
;	3   :		   
;	4   :		SDA      STOP

;	    SCL  SDA 
;	        
;=======================================================================
ERR
;	BTFSS	FLAG, ERR		;    ?
;	MOVWF	ERCODE			;  ,   
;	BSF		FLAG, ERR1		;    
	RETLW	0				;    W
;=======================================================================
	END
